Subject: Re: Anyone using "PowerPC" little-endian mode?

From: Gary Thomas <[email-masked]>
Date: Thu, 03 Jun 2010 06:25:01 -0600

On 06/03/2010 06:20 AM, Paul Mackerras wrote:
> Currently the kernel supports processes running in little-endian mode
> on machines that have a little-endian mode (as opposed to an endian
> bit in the TLB entry like most embedded PowerPC processors do, which
> is a much better idea).  Little-endian mode comes in two flavours:
> so-called "PowerPC" little-endian mode, which works by swizzling the
> bottom 3 bits of the address, and "true" little-endian mode, which
> actually swaps the order of the bytes read from or written to memory.
> The classic 32-bit processors (603, 604, 750, 74xx, and derivatives)
> implemented PowerPC little-endian mode, and I think some early 64-bit
> processors did also.  POWER6 and POWER7 implement true little-endian
> mode.  POWER4, PPC970 and POWER5 don't implement any little-endian
> mode.
>
> Is anyone actually using little-endian mode processes on processors
> that implement PowerPC little-endian mode?  One of the ways that we
> could make the alignment interrupt handler go faster is by removing
> the code for address swizzling that we have in order to handle PowerPC
> little-endian mode.  If nobody is actually using it, we should
> remove it and make the code simpler and faster.

I don't know about today, but my recollection is that the only
use of little-endian mode on PowerPC was during the early days
attempt to run Windows-NT.

-- 
------------------------------------------------------------
Gary Thomas                 |  Consulting for the
MLB Associates              |    Embedded world
------------------------------------------------------------